function roots_of_Polynomial
% clc
% clear
close all
global f lambda
% f=inline('256*x.^9-576*x.^7+432*x.^5-120*x.^3+9*x','x');
f=@(x) 256*x.^9-576*x.^7+432*x.^5-120*x.^3+9*x;



% solution, f(x)=0
% x1 = 0.342,  lambda = 1
% x2 = 0.6428, lambda = -1
% x3 = 0.866,  lambda = 1
% x4 = 0.9848, lambda = -1


% different initial conditions (close to the previous solution)
x0=0.35;
lambda=-1; % set to 1 or -1
tmax=10;

odeSolve=ode15s(@f_dxdt,[0,tmax],x0);


tspan = [0,1];
% plot function
figure
subplot(2,1,1)
fplot(f, tspan)
grid on
title('f(x)')

subplot(2,1,2)
plot(odeSolve.x, odeSolve.y)
grid on
title('root of f(x)')


% root of the polynomial computed using ODE, x(Tmax)
x_odeSolution=odeSolve.y(:,end)

% error
fprintf('Error of the computation: |f(x_odeSolution)|=%g \n ',abs(f(x_odeSolution)));




end


function dxdt = f_dxdt(t,x)
global f lambda
dxdt = lambda*f(x) ;

end


